=== debian/changelog ===
hashrat (1.25+ds-2) unstable; urgency=medium

  * d/control: Bump Standards-Version to 4.7.2
  * d/p/Fix-build-with-GCC-15.patch: New Patch (Closes: #1096796)

 -- Matheus Polkorny <mpolkorny@gmail.com>  Sun, 07 Sep 2025 23:27:25 -0300

hashrat (1.25+ds-1) unstable; urgency=medium

  * New upstream version 1.25+ds
  * d/copyright:
    - Update to reflect upstream copyright changes
    - Use wildcard to exclude precompiled library versions
  * d/patches:
    - Fix-libUseful-Makefile.patch: Refresh patch
    - Fix-manpage-font-formatting.patch: Drop patch applied upstream
    - Fix-some-spelling-errors-in-manpage-and-source-code.patch: Update patch
  * d/watch: Add filenamemangle to fix tarball naming and avoid warning

 -- Matheus Polkorny <mpolkorny@gmail.com>  Mon, 17 Mar 2025 15:04:42 -0300
