=== debian/watch ===
version=4
opts="searchmode=plain, \
      filenamemangle=s%v?@ANY_VERSION@%@PACKAGE@-$1.tar.gz%, \
      dversionmangle=s/@DEB_EXT@//, \
      repacksuffix=+ds" \
https://api.github.com/repos/ColumPaget/Hashrat/releases?per_page=100 \
https://api.github.com/repos/ColumPaget/Hashrat/tarball/@ANY_VERSION@
